      program mak
      common names(200)
      character*11 names
      logical chonly
      character*2 fion(10)
      write(*,*) 'Running 03-makin.f'
      open(2,file='in.dat')
      do i=1,3
        read(2,*) 
      enddo
      read(2,*)nrun
      do i=1,22
        read(2,*) 
      enddo
      read(2,*)nspec
      read(2,*)    
      istr=0
      do ispec=1,nspec 
         read(2,*)eps,n,itry,ratmov,ratexc,z,d,chonly,fion(ispec)
         if (chonly) istr=istr+1
      enddo
      close(2)

      call gnames

      mag=12584210    
!for each run!  
      do i=1,nrun
!open in001,in002, etc.
        open(2,file=names(i))
        mag=mag+1
!write this mag counter thingy and         
        write(2,*)mag
!then total number of ion species as well as structural (channel only) ions (in this case, 1, for oxygen)
        write(2,*)nspec,istr
       
        do ispec=1,nspec
!just creating the file names here I guess?     
          if (i.le.9) then
            write(2,'("gz-",a2,".00",i1,"   gin-",a2,".00",i1)')
     :      fion(ispec),i,fion(ispec),i
          elseif (i.le.99) then
            write(2,'("gz-",a2,".0",i2,"   gin-",a2,".0",i2)')
     :      fion(ispec),i,fion(ispec),i
          else
            write(2,'("gz-",a2,".",i3,"   gin-",a2,".",i3)')
     :      fion(ispec),i,fion(ispec),i
          endif
        
        enddo
      
        if (i.le.9) then
          write(2,'("gz-Ch.00",i1,"   gin-Ch.00",i1)')i,i
        elseif (i.le.99) then
          write(2,'("gz-Ch.0",i2,"   gin-Ch.0",i2)')i,i
        else
          write(2,'("gz-Ch.",i3,"   gin-Ch.",i3)')i,i
        endif
        
        if (i.le.9) then
          write(2,'("c.00",i1)')i
        elseif (i.le.99) then
          write(2,'("c.0",i2)')i
        else
          write(2,'("c.",i3)')i
        endif
        
        if (i.le.9) then
          write(2,'("o.00",i1)')i
        elseif (i.le.99) then
          write(2,'("o.0",i2)')i
        else
          write(2,'("o.",i3)')i
        endif
!istr will be 1 if we just have oxygen as a structural ion
!so count 3 to 4
!so, why count 3 to 4????. this gives us Na and Ca, but only because the ion species are
!declared last in in.dat???
        do ispec=istr+2,nspec

         if (i.le.9) then
            write(2,'("azocc",a2,".00",i1,
     :            "    afilt",a2,".00",i1,
     :            "    achan",a2,".00",i1,
     :            "    abulk",a2,".00",i1)')
     :       fion(ispec),i,fion(ispec),i,fion(ispec),i,fion(ispec),i
         elseif (i.le.99) then
            write(2,'("azocc",a2,".0",i2,
     :            "    afilt",a2,".0",i2,
     :            "    achan",a2,".0",i2,
     :            "    abulk",a2,".0",i2)')
     :       fion(ispec),i,fion(ispec),i,fion(ispec),i,fion(ispec),i
         else
            write(2,'("azocc",a2,".",i3,
     :            "    afilt",a2,".",i3,
     :            "    achan",a2,".",i3,
     :            "    abulk",a2,".",i3)')
     :       fion(ispec),i,fion(ispec),i,fion(ispec),i,fion(ispec),i
         endif
       
        enddo

         if (i.le.9) then
           write(2,'("h.00",i1)')i
         elseif (i.le.99) then
           write(2,'("h.0",i2)')i
         else
           write(2,'("h.",i3)')i
         endif
        
         if (i.le.9) then
           write(2,'("data.00",i1)')i
         elseif (i.le.99) then
           write(2,'("data.0",i2)')i
         else
           write(2,'("data.",i3)')i
         endif
        
         if (i.le.9) then
           write(2,'("occ.00",i1)')i
         elseif (i.le.99) then
           write(2,'("occ.0",i2)')i
         else
           write(2,'("occ.",i3)')i
         endif
!radial distribution functions for each ion combination        
         do ispec=1,nspec
           do jspec=1,nspec
              if (i.le.9) then
                write(2,'("rdf-",a2,"-",a2,".00",i1)')
     :          fion(ispec),fion(jspec),i
              elseif (i.le.99) then
                write(2,'("rdf-",a2,"-",a2,".0",i2)')
     :          fion(ispec),fion(jspec),i
              else
                write(2,'("rdf-",a2,"-",a2,".",i3)')
     :          fion(ispec),fion(jspec),i
              endif
           enddo   
         enddo             

         close(2)
      enddo

      stop
      end
      

      subroutine gnames
      common names(200)
      character*11 names
      names(1)= "in001"
      names(2)= "in002"
      names(3)= "in003"
      names(4)= "in004"
      names(5)= "in005"
      names(6)= "in006"
      names(7)= "in007"
      names(8)= "in008"
      names(9)= "in009"
      names(10)="in010"
      names(11)="in011"
      names(12)="in012"
      names(13)="in013"
      names(14)="in014"
      names(15)="in015"
      names(16)="in016"
      names(17)="in017"
      names(18)="in018"
      names(19)="in019"
      names(20)="in020"
      names(21)="in021"
      names(22)="in022"
      names(23)="in023"
      names(24)="in024"
      names(25)="in025"
      names(26)="in026"
      names(27)="in027"
      names(28)="in028"
      names(29)="in029"
      names(30)="in030"
      names(31)="in031"
      names(32)="in032"
      names(33)="in033"
      names(34)="in034"
      names(35)="in035"
      names(36)="in036"
      names(37)="in037"
      names(38)="in038"
      names(39)="in039"
      names(40)="in040"
      names(41)="in041"
      names(42)="in042"
      names(43)="in043"
      names(44)="in044"
      names(45)="in045"
      names(46)="in046"
      names(47)="in047"
      names(48)="in048"
      names(49)="in049"
      names(50)="in050"
      names(51)="in051"
      names(52)="in052"
      names(53)="in053"
      names(54)="in054"
      names(55)="in055"
      names(56)="in056"
      names(57)="in057"
      names(58)="in058"
      names(59)="in059"
      names(60)="in060"
      names(61)="in061"
      names(62)="in062"
      names(63)="in063"
      names(64)="in064"
      names(65)="in065"
      names(66)="in066"
      names(67)="in067"
      names(68)="in068"
      names(69)="in069"
      names(70)="in070"
      names(71)="in071"
      names(72)="in072"
      names(73)="in073"
      names(74)="in074"
      names(75)="in075"
      names(76)="in076"
      names(77)="in077"
      names(78)="in078"
      names(79)="in079"
      names(80)="in080"
      names(81)="in081"
      names(82)="in082"
      names(83)="in083"
      names(84)="in084"
      names(85)="in085"
      names(86)="in086"
      names(87)="in087"
      names(88)="in088"
      names(89)="in089"
      names(90)="in090"
      names(91)="in091"
      names(92)="in092"
      names(93)="in093"
      names(94)="in094"
      names(95)="in095"
      names(96)="in096"
      names(97)="in097"
      names(98)="in098"
      names(99)="in099"
      names(100)="in100"
      names(101)="in101"
      names(102)="in102"
      names(103)="in103"
      names(104)="in104"
      names(105)="in105"
      names(106)="in106"
      names(107)="in107"
      names(108)="in108"
      names(109)="in109"
      names(110)="in110"
      names(111)="in111"
      names(112)="in112"
      names(113)="in113"
      names(114)="in114"
      names(115)="in115"
      names(116)="in116"
      names(117)="in117"
      names(118)="in118"
      names(119)="in119"
      names(120)="in120"
      names(121)="in121"
      names(122)="in122"
      names(123)="in123"
      names(124)="in124"
      names(125)="in125"
      names(126)="in126"
      names(127)="in127"
      names(128)="in128"
      names(129)="in129"
      names(130)="in130"
      names(131)="in131"
      names(132)="in132"
      names(133)="in133"
      names(134)="in134"
      names(135)="in135"
      names(136)="in136"
      names(137)="in137"
      names(138)="in138"
      names(139)="in139"
      names(140)="in140"
      names(141)="in141"
      names(142)="in142"
      names(143)="in143"
      names(144)="in144"
      names(145)="in145"
      names(146)="in146"
      names(147)="in147"
      names(148)="in148"
      names(149)="in149"
      names(150)="in150"
      names(151)="in151"
      names(152)="in152"
      names(153)="in153"
      names(154)="in154"
      names(155)="in155"
      names(156)="in156"
      names(157)="in157"
      names(158)="in158"
      names(159)="in159"
      names(160)="in160"
      names(161)="in161"
      names(162)="in162"
      names(163)="in163"
      names(164)="in164"
      names(165)="in165"
      names(166)="in166"
      names(167)="in167"
      names(168)="in168"
      names(169)="in169"
      names(170)="in170"
      names(171)="in171"
      names(172)="in172"
      names(173)="in173"
      names(174)="in174"
      names(175)="in175"
      names(176)="in176"
      names(177)="in177"
      names(178)="in178"
      names(179)="in179"
      names(180)="in180"
      names(181)="in181"
      names(182)="in182"
      names(183)="in183"
      names(184)="in184"
      names(185)="in185"
      names(186)="in186"
      names(187)="in187"
      names(188)="in188"
      names(189)="in189"
      names(190)="in190"
      names(191)="in191"
      names(192)="in192"
      names(193)="in193"
      names(194)="in194"
      names(195)="in195"
      names(196)="in196"
      names(197)="in197"
      names(198)="in198"
      names(199)="in199"
      names(200)="in200"
      return       
      end         
