      program merge
      implicit doubleprecision (a-h,o-z)
      common// fin
      character*11 fgz(10,400),fgin(10,400),fc(400),fo(400),
     :        fnaca(10,4,400),fh(400),fout(10),fin(400),fdata(400),
     :        focc(400)
      character*15 frdf(10,10,400),favrdf(10,10)
      character*2  fion(10)
      character*4  fsalt(3)
      dimension z(4,4000),ci(10,400,4000),cav(10,4000),vi(4,4000)
      dimension dz(4,4000),ani(10,400,4000),aniav(10,4000)
      dimension rmxi(10,400,4000),rmxav(10,4000)
      dimension zl(4),rr(4),d(4),dzg(10,5),drg(10),ndat(400),nzg(10,5)
      dimension nrg(10),np(4),nz1(10)
      dimension cbulk(10,400),cchan(10,400),cfilt(10,400),czocc(10,400),
     :          ctot(10,400)
      dimension avbulk(10,400),avchan(10,400),avfilt(10,400),
     :          avzocc(10,400),avtot(10,400)
      dimension erbulk(10,400),erchan(10,400),erfilt(10,400),
     :          erzocc(10,400),ertot(10,400)
      dimension aocc(3,0:4,0:4,0:4,0:4)
      dimension avocc(3,0:4,0:4,0:4)
      dimension htot(7,400),htot0(7),
     :          occui(0:4,0:4,0:4,400),occuj(0:4,0:4,0:4,400)
      dimension isalt(3),ctarg(3),chex(3),ratgc(3)
      dimension dncl(400),dnna(400),dnca(400)
      dimension rdf(3,10,10,4000),rrdf(10,10,4000)
      character*13 chr11
      character*1  chr1
      character*2  chr2
      character*3  chr3
      character*4  chr4
      character*5  chr5
      character*6  chr6
      character*7  chr7
      character*11 faname(10,400)
      dimension    indx(400)
      logical      chonlyi,calgin,calrdf

c######################################################################
      
      open(2,file="in.dat")

      do i=1,20
        read(2,*) 
      enddo
      read(2,*)isave 
      read(2,*)calgin
      read(2,*)calrdf
      read(2,*)
      read(2,*)

c---species---
      read(2,*)nspec
      read(2,*)       
      do ispec=2,nspec 
         read(2,*)ni,itryi,ratmovi,
     :            ratexci,zi,di,chonlyi,
     :            fion(ispec)
      enddo      

      read(2,*)
      read(2,*)
c---grand canonical---
      read(2,*)nsalt
      read(2,*)
      do i=1,nsalt
        read(2,*)isalti,ctargi,chexi,ratgri,fsalt(i)
      enddo

      close(2)

      avog=6.02214d23
      tosi=1.0/(1.d-10)**3/avog/1000.
     
      call names
      
c######################################################################
      
      open(2,file="o")
      read(2,*)n
      do i=1,n 
       read(2,*)indx(i)
c       write(*,*)i,indx(i)
      enddo
     
c######################################################################
      
      do ii=1,n   
        i=indx(ii)
        open(2,file=fin(i))
        read(2,*)mag
        read(2,*)nspec0,istr
        do ispec=2,nspec0
           read(2,*) fgz(ispec,i),fgin(ispec,i)
        enddo
        read(2,*)fc(i)
        read(2,*)fo(i)
        do ispec=istr+2,nspec0
           read(2,*)fnaca(ispec,1,i),fnaca(ispec,2,i),fnaca(ispec,3,i),
     :          fnaca(ispec,4,i)
        enddo
        read(2,*)fh(i)
        read(2,*)fdata(i)
        read(2,*)focc(i)
        do ispec=2,nspec0
          do jspec=2,nspec0
           read(2,*) frdf(ispec,jspec,i)
          enddo
        enddo
        close(2)
      enddo
      
c######################################################################

      ntot=0
      do ii=1,n
            i=indx(ii)
            open(2,file=fc(i))
            read(2,*)npart,ndat(i)
            ntot=ntot+ndat(i)
            close(2)
      enddo

c######################################################################
      
      ii=indx(1)
      open(2,file=fc(ii))
      read(2,*) nspec,istep                             
      read(2,*)            
      read(2,*)            
      read(2,*)            
      read(2,*)
      read(2,*)            
      do ispec=1,nspec
         read(2,*) np(ispec),d(ispec)
         read(2,*) nz1(ispec),nrgz,nrgr
         read(2,*)
         do i=1,np(ispec)
               read(2,*)rx,ry,rz
         enddo      
         read(2,*)
      enddo      
      close(2)
     
c######################################################################
      
      do ispec=2,nspec
      
        do ii=1,n
            i=indx(ii)
            open(3,file=fgz(ispec,i))
c            write(*,*)fgz(ispec,i)
            do j=1,nz1(ispec)
                  read(3,*)z(ispec,j),ci(ispec,i,j)
     :                     ,ani(ispec,i,j),
     :                     vi(ispec,j),dz(ispec,i)
            enddo
            close(3)
        enddo
      
      enddo 

c######################################################################
      
      open(2,file="fgz-names")
      do ispec=2,nspec
       write(2,'(a2,"-gz.av")')fion(ispec)
      enddo
      close(2)

      open(2,file="fgz-names")
      do ispec=2,nspec
       read(2,*)fout(ispec)
      enddo
      close(2)

      do ispec=2,nspec
     
        open(2,file=fout(ispec))
        do j=1,nz1(ispec)
            cav(ispec,j)=0
            aniav(ispec,j)=0
            do ii=1,n
              i=indx(ii)
              cav(ispec,j)=cav(ispec,j)
     :        +(dble(ndat(i))/dble(ntot))*ci(ispec,i,j)
              aniav(ispec,j)=aniav(ispec,j)
     :        +(dble(ndat(i))/dble(ntot))*ani(ispec,i,j)
            enddo
            write(2,'(6(1x,f10.5))')z(ispec,j),cav(ispec,j)
     :                     ,aniav(ispec,j),
     :                     vi(ispec,j),dz(ispec,j)
        enddo  
        close(2)
      
      enddo
      
c######################################################################
      
      write(*,*)" Number of configurations = ",ntot
      
      do ii=1,n
            i=indx(ii) 
            open(2,file=fo(i))
            do j=1,5    
              read(2,*)
            enddo
            do j=1,nsalt
             read(2,*)
            enddo 
            read(2,*)
            read(2,*)
            do j=1,nspec+3
              read(2,*)
            enddo
            do ispec=2,nspec
            read(2,*)chr2,chr4,chr1,cbulk(ispec,i),chr1,cchan(ispec,i),
     :               chr1,cfilt(ispec,i),chr1,czocc(ispec,i),chr1,
     :               ctot(ispec,i)
            enddo
            close(2)
      enddo

c######################################################################
      
      open(2,file="fa-names.dat")
      do ispec=2,nspec
        write(2,'(a2,"-abulk.av")')fion(ispec)
        write(2,'(a2,"-achan.av")')fion(ispec)
        write(2,'(a2,"-afilt.av")')fion(ispec)
        write(2,'(a2,"-azocc.av")')fion(ispec)
        write(2,'(a2,"-atot.av")')fion(ispec)
      enddo
      close(2)

      do ii=1,n
        i=indx(ii)
        ntot0=ntot0+ndat(i)
       
        do ispec=2,nspec
          avbulk(ispec,ii)=0.0
          avchan(ispec,ii)=0.0
          avfilt(ispec,ii)=0.0
          avzocc(ispec,ii)=0.0
          avtot(ispec,ii)=0.0
          erbulk(ispec,ii)=0.0
          erchan(ispec,ii)=0.0
          erfilt(ispec,ii)=0.0
          erzocc(ispec,ii)=0.0
          ertot(ispec,ii)=0.0
        enddo

        do jj=1,ii
           j=indx(jj)

           do ispec=2,nspec
              avbulk(ispec,ii)=avbulk(ispec,ii)
     :                     +(dble(ndat(j))/dble(ntot0))
     :                     *cbulk(ispec,j)
              avchan(ispec,ii)=avchan(ispec,ii)
     :                     +(dble(ndat(j))/dble(ntot0))
     :                     *cchan(ispec,j)
              avfilt(ispec,ii)=avfilt(ispec,ii)
     :                     +(dble(ndat(j))/dble(ntot0))
     :                     *cfilt(ispec,j)
              avzocc(ispec,ii)=avzocc(ispec,ii)
     :                     +(dble(ndat(j))/dble(ntot0))
     :                     *czocc(ispec,j)
              avtot(ispec,ii)=avtot(ispec,ii)
     :                     +(dble(ndat(j))/dble(ntot))
     :                     *ctot(ispec,j)
           enddo
        
        enddo 

        do jj=1,ii
           j=indx(jj)

           do ispec=2,nspec
              erbulk(ispec,ii)=erbulk(ispec,ii)
     :                     +(cbulk(ispec,j)-avbulk(ispec,ii))**2
              erchan(ispec,ii)=erchan(ispec,ii)
     :                     +(cchan(ispec,j)-avchan(ispec,ii))**2
              erfilt(ispec,ii)=erfilt(ispec,ii)
     :                     +(cfilt(ispec,j)-avfilt(ispec,ii))**2
              erzocc(ispec,ii)=erzocc(ispec,ii)
     :                     +(czocc(ispec,j)-avzocc(ispec,ii))**2
              ertot(ispec,ii)=ertot(ispec,ii)
     :                     +(ctot(ispec,j)-avtot(ispec,ii))**2
           enddo
        
        enddo 

        do ispec=2,nspec
           erbulk(ispec,ii)=dsqrt(erbulk(ispec,ii))/dble(ii)
           erchan(ispec,ii)=dsqrt(erchan(ispec,ii))/dble(ii)
           erfilt(ispec,ii)=dsqrt(erfilt(ispec,ii))/dble(ii)
           erzocc(ispec,ii)=dsqrt(erzocc(ispec,ii))/dble(ii)
           ertot(ispec,ii)=dsqrt(ertot(ispec,ii))/dble(ii)
        enddo

      enddo        

c######################################################################
      
      open(2,file="fa-names.dat")
      do ispec=2,nspec  
        read(2,*)faname(ispec,1)
        read(2,*)faname(ispec,2)
        read(2,*)faname(ispec,3)
        read(2,*)faname(ispec,4)
        read(2,*)faname(ispec,5)
        open(12,file=faname(ispec,1))
        open(22,file=faname(ispec,2))
        open(32,file=faname(ispec,3))
        open(42,file=faname(ispec,4))
        open(52,file=faname(ispec,5))
        do ii=1,n
          write(12,*)ii,avbulk(ispec,ii),erbulk(ispec,ii)
          write(22,*)ii,avchan(ispec,ii),erchan(ispec,ii)
          write(32,*)ii,avfilt(ispec,ii),erfilt(ispec,ii)
          write(42,*)ii,avzocc(ispec,ii),erzocc(ispec,ii)
          write(52,*)ii,avtot(ispec,ii),ertot(ispec,ii)
        enddo
        close(12)
        close(22)
        close(32)
        close(42)
        close(52)
      enddo
      close(2)

c######################################################################

      write(*,'(65("_"))')
      write(*,'(10x,"|",4x,"BULK",17x,"|",3x,"TOTAL  ")')
      do ispec=2,nspec
        write(*,'(1x,a2,"  ion: ",1("|",1x,e10.5,1x,"(",e10.5,") "),
     :      "|",f8.3,1x,"(",f8.3,")")')fion(ispec),
     :      avbulk(ispec,n),erbulk(Ispec,n),
     :      avtot(ispec,n),ertot(Ispec,n)
      enddo

      write(*,'(87("_"))')
      write(*,'(10x,"|",4x,"CHANNEL",14x,"|",3x,"FILTER",16x,"|",
     :        3x,"CENTER ")')
      do ispec=2,nspec
        write(*,'(1x,a2,"  ion: ",3("|",1x,f10.7,1x,"(",f10.7,") "))')
     ;    fion(ispec),
     :    avchan(ispec,n),erchan(ispec,n),
     :    avfilt(ispec,n),erfilt(ispec,n),
     :    avzocc(ispec,n),erzocc(ispec,n)
      enddo
      write(*,'(87("_"))')

c######################################################################

      open(2,file="fa-names.dat")
      do ispec=istr+2,nspec
        write(2,'(a2,"-szocc.av")')fion(ispec)
        write(2,'(a2,"-sfilt.av")')fion(ispec)
        write(2,'(a2,"-schan.av")')fion(ispec)
        write(2,'(a2,"-sbulk.av")')fion(ispec)
      enddo
      close(2)

      open(2,file="fa-names.dat")
      do ispec=istr+2,nspec
        do j=1,4
          read(2,*)faname(ispec,j)
        enddo
      enddo
      close(2)

      do ispec=istr+2,nspec
         do j=1,4 
            open(3,file=faname(ispec,j))   
            kk=0 
            avav=0.0
            do ii=1,n
              i=indx(ii)
                open(2,file=fnaca(ispec,j,i))
                nsub=ndat(i)/isave 
c                write(*,*)ispec,j,ii,fnaca(ispec,j,i),nsub
                do k=1,nsub    
                  kk=kk+1
                  read(2,*)kkk,avetot,avesub
c                  if (k.gt.1) then
c                    subtot(k)=k*avetot(k)-(k-1)*avetot(k-1)
c                  else
c                    subtot(k)=avetot(k)
c                  endif
                  avav=avav+avesub
                  write(3,*)kk,avav/dble(kk),avesub
                enddo
                close(2)
            enddo
            close(3) 
         enddo
      enddo                  

c######################################################################

      nfree=nspec-istr
      nocc=5**nfree
      
      do i=0,4
      do j=0,4
      do k=0,4
      do m=0,4
       do ireg=1,3
         aocc(ireg,i,j,k,m)=0.0
         avocc(ireg,j,k,m)=0.0
       enddo  
      enddo
      enddo
      enddo
      enddo

      do iii=1,n
        ii=indx(iii)
        open(12,file=focc(ii))
        dnorm=dble(ndat(i))/dble(ntot)
      
         if (nfree.eq.2) then

            do ireg=1,3
              do i=0,4
              do j=0,4
                 k=0  
                 m=0  
                 read(12,*)i0,j0,aocci
                 aocc(ireg,i,j,k,m)=aocc(ireg,i,j,k,m)+dnorm*aocci
              enddo
              enddo
              read(12,*)
            enddo     
            read(12,*)
                 
            do ireg=1,3      
              do j=0,4
                read(12,*)j0,azcl  
                avocc(ireg,j,k,m)=avocc(ireg,j,k,m)+dnorm*azcl
              enddo
              write(12,*)
            enddo      

         elseif (nfree.eq.3) then

            do ireg=1,3
              do i=0,4
              do j=0,4
              do k=0,4
                 m=0  
                 read(12,*)i0,j0,k0,aocci
                 aocc(ireg,i,j,k,m)=aocc(ireg,i,j,k,m)+dnorm*aocci
              enddo
              enddo
              enddo
              read(12,*)
            enddo     
            read(12,*)
      
            do ireg=1,3      
              do j=0,4
              do k=0,4
                read(12,*)j0,k0,azcl  
                avocc(ireg,j,k,m)=avocc(ireg,j,k,m)+dnorm*azcl
              enddo
              enddo
              read(12,*)
            enddo      
                 
         elseif (nfree.eq.4) then

            do ireg=1,3
              do i=0,4
              do j=0,4
              do k=0,4
              do m=0,4
                 read(12,*)i0,j0,k0,m0,aocci
                 aocc(ireg,i,j,k,m)=aocc(ireg,i,j,k,m)+dnorm*aocci
              enddo
              enddo
              enddo
              enddo
              read(12,*)
            enddo     
            read(12,*)
      
            do ireg=1,3      
              do j=0,4
              do k=0,4
              do m=0,4
                read(12,*)j0,k0,m0,azcl  
                avocc(ireg,j,k,m)=avocc(ireg,j,k,m)+dnorm*azcl
              enddo
              enddo
              enddo
              read(12,*)
            enddo      

         endif

      close(12)
     
      enddo

c######################################################################
     
      open(12,file="occupancies.av")

         if (nfree.eq.2) then
                 
            do ireg=1,3      
              do j=0,4
                azcl=avocc(ireg,j,0,0)
                write(12,'(1(i1,1x),f15.10)')j,azcl  
              enddo
              write(12,*)
            enddo      

         elseif (nfree.eq.3) then

            do ireg=1,3      
              do j=0,4
              do k=0,4
                azcl=avocc(ireg,j,k,0)
                write(12,'(2(i1,1x),f15.10)')j,k,azcl  
              enddo
              enddo
              write(12,*)
            enddo      
                 
         elseif (nfree.eq.4) then

            do ireg=1,3      
              do j=0,4
              do k=0,4
              do m=0,4
                azcl=avocc(ireg,j,k,m)
                write(12,'(3(i1,1x),f15.10)')j,k,m,azcl  
              enddo
              enddo
              enddo
              write(12,*)
            enddo      

         endif

      close(12)

c######################################################################


      stop
      end

c######################################################################
c######################################################################
c######################################################################
      
      subroutine names
      common// fin
      character*11 fin(400)       
      
      fin(1) ="in001"
      fin(2) ="in002"
      fin(3) ="in003"
      fin(4) ="in004"
      fin(5) ="in005"
      fin(6) ="in006"
      fin(7) ="in007"
      fin(8) ="in008"
      fin(9) ="in009"
      fin(10)="in010"
      fin(11)="in011"
      fin(12)="in012"
      fin(13)="in013"
      fin(14)="in014"
      fin(15)="in015"
      fin(16)="in016"
      fin(17)="in017"
      fin(18)="in018"
      fin(19)="in019"
      fin(20)="in020"
      fin(21)="in021"
      fin(22)="in022"
      fin(23)="in023"
      fin(24)="in024"
      fin(25)="in025"
      fin(26)="in026"
      fin(27)="in027"
      fin(28)="in028"
      fin(29)="in029"
      fin(30)="in030"
      fin(31)="in031"
      fin(32)="in032"
      fin(33)="in033"
      fin(34)="in034"
      fin(35)="in035"
      fin(36)="in036"
      fin(37)="in037"
      fin(38)="in038"
      fin(39)="in039"
      fin(40)="in040"
      fin(41)="in041"
      fin(42)="in042"
      fin(43)="in043"
      fin(44)="in044"
      fin(45)="in045"
      fin(46)="in046"
      fin(47)="in047"
      fin(48)="in048"
      fin(49)="in049"
      fin(50)="in050"
      fin(51)="in051"
      fin(52)="in052"
      fin(53)="in053"
      fin(54)="in054"
      fin(55)="in055"
      fin(56)="in056"
      fin(57)="in057"
      fin(58)="in058"
      fin(59)="in059"
      fin(60)="in060"
      fin(61)="in061"
      fin(62)="in062"
      fin(63)="in063"
      fin(64)="in064"
      fin(65)="in065"
      fin(66)="in066"
      fin(67)="in067"
      fin(68)="in068"
      fin(69)="in069"
      fin(70)="in070"
      fin(71)="in071"
      fin(72)="in072"
      fin(73)="in073"
      fin(74)="in074"
      fin(75)="in075"
      fin(76)="in076"
      fin(77)="in077"
      fin(78)="in078"
      fin(79)="in079"
      fin(80)="in080"
      fin(81)="in081"
      fin(82)="in082"
      fin(83)="in083"
      fin(84)="in084"
      fin(85)="in085"
      fin(86)="in086"
      fin(87)="in087"
      fin(88)="in088"
      fin(89)="in089"
      fin(90)="in090"
      fin(91)="in091"
      fin(92)="in092"
      fin(93)="in093"
      fin(94)="in094"
      fin(95)="in095"
      fin(96)="in096"
      fin(97)="in097"
      fin(98)="in098"
      fin(99)="in099"
      fin(100) ="in100"
                 
      fin(101) ="in101"
      fin(102) ="in102"
      fin(103) ="in103"
      fin(104) ="in104"
      fin(105) ="in105"
      fin(106) ="in106"
      fin(107) ="in107"
      fin(108) ="in108"
      fin(109) ="in109"
      fin(110)="in110"
      fin(111)="in111"
      fin(112)="in112"
      fin(113)="in113"
      fin(114)="in114"
      fin(115)="in115"
      fin(116)="in116"
      fin(117)="in117"
      fin(118)="in118"
      fin(119)="in119"
      fin(120)="in120"
      fin(121)="in121"
      fin(122)="in122"
      fin(123)="in123"
      fin(124)="in124"
      fin(125)="in125"
      fin(126)="in126"
      fin(127)="in127"
      fin(128)="in128"
      fin(129)="in129"
      fin(130)="in130"
      fin(131)="in131"
      fin(132)="in132"
      fin(133)="in133"
      fin(134)="in134"
      fin(135)="in135"
      fin(136)="in136"
      fin(137)="in137"
      fin(138)="in138"
      fin(139)="in139"
      fin(140)="in140"
      fin(141)="in141"
      fin(142)="in142"
      fin(143)="in143"
      fin(144)="in144"
      fin(145)="in145"
      fin(146)="in146"
      fin(147)="in147"
      fin(148)="in148"
      fin(149)="in149"
      fin(150)="in150"
      fin(151)="in151"
      fin(152)="in152"
      fin(153)="in153"
      fin(154)="in154"
      fin(155)="in155"
      fin(156)="in156"
      fin(157)="in157"
      fin(158)="in158"
      fin(159)="in159"
      fin(160)="in160"
      fin(161)="in161"
      fin(162)="in162"
      fin(163)="in163"
      fin(164)="in164"
      fin(165)="in165"
      fin(166)="in166"
      fin(167)="in167"
      fin(168)="in168"
      fin(169)="in169"
      fin(170)="in170"
      fin(171)="in171"
      fin(172)="in172"
      fin(173)="in173"
      fin(174)="in174"
      fin(175)="in175"
      fin(176)="in176"
      fin(177)="in177"
      fin(178)="in178"
      fin(179)="in179"
      fin(180)="in180"
      fin(181)="in181"
      fin(182)="in182"
      fin(183)="in183"
      fin(184)="in184"
      fin(185)="in185"
      fin(186)="in186"
      fin(187)="in187"
      fin(188)="in188"
      fin(189)="in189"
      fin(190)="in190"
      fin(191)="in191"
      fin(192)="in192"
      fin(193)="in193"
      fin(194)="in194"
      fin(195)="in195"
      fin(196)="in196"
      fin(197)="in197"
      fin(198)="in198"
      fin(199)="in199"
      fin(200)="in200"

      fin(201)="in201"
      fin(202)="in202"
      fin(203)="in203"
      fin(204)="in204"
      fin(205)="in205"
      fin(206)="in206"
      fin(207)="in207"
      fin(208)="in208"
      fin(209)="in209"
      fin(210)="in210"
      fin(211)="in211"
      fin(212)="in212"
      fin(213)="in213"
      fin(214)="in214"
      fin(215)="in215"
      fin(216)="in216"
      fin(217)="in217"
      fin(218)="in218"
      fin(219)="in219"
      fin(220)="in220"
      fin(221)="in221"
      fin(222)="in222"
      fin(223)="in223"
      fin(224)="in224"
      fin(225)="in225"
      fin(226)="in226"
      fin(227)="in227"
      fin(228)="in228"
      fin(229)="in229"
      fin(230)="in230"
      fin(231)="in231"
      fin(232)="in232"
      fin(233)="in233"
      fin(234)="in234"
      fin(235)="in235"
      fin(236)="in236"
      fin(237)="in237"
      fin(238)="in238"
      fin(239)="in239"
      fin(240)="in240"
      fin(241)="in241"
      fin(242)="in242"
      fin(243)="in243"
      fin(244)="in244"
      fin(245)="in245"
      fin(246)="in246"
      fin(247)="in247"
      fin(248)="in248"
      fin(249)="in249"
      fin(250)="in250"
      fin(251)="in251"
      fin(252)="in252"
      fin(253)="in253"
      fin(254)="in254"
      fin(255)="in255"
      fin(256)="in256"
      fin(257)="in257"
      fin(258)="in258"
      fin(259)="in259"
      fin(260)="in260"
      fin(261)="in261"
      fin(262)="in262"
      fin(263)="in263"
      fin(264)="in264"
      fin(265)="in265"
      fin(266)="in266"
      fin(267)="in267"
      fin(268)="in268"
      fin(269)="in269"
      fin(270)="in270"
      fin(271)="in271"
      fin(272)="in272"
      fin(273)="in273"
      fin(274)="in274"
      fin(275)="in275"
      fin(276)="in276"
      fin(277)="in277"
      fin(278)="in278"
      fin(279)="in279"
      fin(280)="in280"
      fin(281)="in281"
      fin(282)="in282"
      fin(283)="in283"
      fin(284)="in284"
      fin(285)="in285"
      fin(286)="in286"
      fin(287)="in287"
      fin(288)="in288"
      fin(289)="in289"
      fin(290)="in290"
      fin(291)="in291"
      fin(292)="in292"
      fin(293)="in293"
      fin(294)="in294"
      fin(295)="in295"
      fin(296)="in296"
      fin(297)="in297"
      fin(298)="in298"
      fin(299)="in299"
      fin(300)="in300"

      fin(301)="in301"
      fin(302)="in302"
      fin(303)="in303"
      fin(304)="in304"
      fin(305)="in305"
      fin(306)="in306"
      fin(307)="in307"
      fin(308)="in308"
      fin(309)="in309"
      fin(310)="in310"
      fin(311)="in311"
      fin(312)="in312"
      fin(313)="in313"
      fin(314)="in314"
      fin(315)="in315"
      fin(316)="in316"
      fin(317)="in317"
      fin(318)="in318"
      fin(319)="in319"
      fin(320)="in320"
      fin(321)="in321"
      fin(322)="in322"
      fin(323)="in323"
      fin(324)="in324"
      fin(325)="in325"
      fin(326)="in326"
      fin(327)="in327"
      fin(328)="in328"
      fin(329)="in329"
      fin(330)="in330"
      fin(331)="in331"
      fin(332)="in332"
      fin(333)="in333"
      fin(334)="in334"
      fin(335)="in335"
      fin(336)="in336"
      fin(337)="in337"
      fin(338)="in338"
      fin(339)="in339"
      fin(340)="in340"
      fin(341)="in341"
      fin(342)="in342"
      fin(343)="in343"
      fin(344)="in344"
      fin(345)="in345"
      fin(346)="in346"
      fin(347)="in347"
      fin(348)="in348"
      fin(349)="in349"
      fin(350)="in350"
      fin(351)="in351"
      fin(352)="in352"
      fin(353)="in353"
      fin(354)="in354"
      fin(355)="in355"
      fin(356)="in356"
      fin(357)="in357"
      fin(358)="in358"
      fin(359)="in359"
      fin(360)="in360"
      fin(361)="in361"
      fin(362)="in362"
      fin(363)="in363"
      fin(364)="in364"
      fin(365)="in365"
      fin(366)="in366"
      fin(367)="in367"
      fin(368)="in368"
      fin(369)="in369"
      fin(370)="in370"
      fin(371)="in371"
      fin(372)="in372"
      fin(373)="in373"
      fin(374)="in374"
      fin(375)="in375"
      fin(376)="in376"
      fin(377)="in377"
      fin(378)="in378"
      fin(379)="in379"
      fin(380)="in380"
      fin(381)="in381"
      fin(382)="in382"
      fin(383)="in383"
      fin(384)="in384"
      fin(385)="in385"
      fin(386)="in386"
      fin(387)="in387"
      fin(388)="in388"
      fin(389)="in389"
      fin(390)="in390"
      fin(391)="in391"
      fin(392)="in392"
      fin(393)="in393"
      fin(394)="in394"
      fin(395)="in395"
      fin(396)="in396"
      fin(397)="in397"
      fin(398)="in398"
      fin(399)="in399"
      fin(400)="in400"

      return     
      end        
                 
