
c_______________________________________________________________________
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      subroutine defgeo
      implicit doubleprecision (a-h,o-z)
      parameter(nionmx=2000,ntotmx=12000,ntrymx=12000,npchmx=2000, 
     :          nspcmx=6,nzgmx=4000,nrgmx=500)
      common/const/ pi,twopi,tosi,u0(4,4),eb(4),beta,dsi,mag
      common/conf/  rx(ntotmx),ry(ntotmx),rz(ntotmx),r2(ntotmx),
     :              indspc(nspcmx,nionmx),rii(ntotmx,ntotmx), 
     :              n(nspcmx),ispcbk(ntotmx)
      common/spec/  d(nspcmx),dd(nspcmx,nspcmx),d2(nspcmx,nspcmx),
     :              z(nspcmx),q(nspcmx),
     :              ratmov(nspcmx),ratexc(nspcmx), 
     :              eps(nspcmx),qstar,itry(nspcmx),
     :              chonly(nspcmx),
     :              nspec,nwh(ntrymx),ntry,istr
      common/geom/  zl(6),rl(6),rlvest,rlcurv,epsw,epspr
      common/patch/ px(npchmx),py(npchmx),pz(npchmx),h(npchmx),
     :              ux(npchmx),uy(npchmx),uz(npchmx),a(npchmx),
     :              amx(npchmx,npchmx),c(npchmx),deps,
     :              rip(ntotmx,npchmx),
     :              npatch,indx(npchmx),npch(10)
      common/moove/ drmax(2),vin(nspcmx),vout(nspcmx),rljpin(nspcmx),
     :              zljpin(nspcmx) 
      common/gc/    chemp(3),ctarg(3),vgc(4,3),riicrn(4,4),
     :              rxnew(4),rynew(4),rznew(4),r2new(4),
     :              chex(3),ctrgcl,ratgr(3),ratgrt,ratreg(4),
     :              zcr1(4,nspcmx),zcr2(4,nspcmx),rcr(4,nspcmx),
     :              iout(4),ispcin(3,4),igcval(3),
     :              isalt(3),ication(3),nsalt,ntot,niter,iter
      common/names/ fion(10),fsalt(10),fgz(10),fgin(10),fc,fout,fh,
     :              fnaca(10,4),fdata,focc,frdf(10,10)
      common/profl/ athist,ataccu,dzg(10,nspcmx),drg, 
     :              vjz(nspcmx,nzgmx),vjin(nspcmx,nrgmx,nrgmx),
     :              rgz(nspcmx,nzgmx),rgin(nspcmx,nrgmx),
     :              gz(nspcmx,nzgmx),gin(nspcmx,nrgmx,nrgmx),
     :              zinlft,rinup,zzreg(0:10,nspcmx),dzgi(nspcmx,nzgmx),
     :              nzg(10,nspcmx),nrg,nrgr,nrgz,nzgtot(nspcmx),
     :              nzreg(nspcmx),calgin
      common/accu/  an(nspcmx),ah(npchmx),anin(4,nspcmx),
     :              zreg1(4,nspcmx),zreg2(4,nspcmx),rreg(4,nspcmx), 
     :              cbulk(nspcmx),zocc,indreg(3,nspcmx,nionmx),
     :              nin(4,nspcmx) 
      common/adj/   amove(2,nspcmx),ajump(2,nspcmx),ajin(2,nspcmx), 
     :              ajout(2,nspcmx),acreat(4,3,2),adest(4,3,2)
      common/bufer/ hold(npchmx), cold(npchmx),ripnew(nspcmx,npchmx),
     :              riinew(nspcmx,ntotmx),dc(npchmx),dh(npchmx),
     :              distin(4) 
      common/simp/  nstep,naver,isave
      common/bulk/  zbulk1,zbulk2,rbulk,vbulk,anaca(nspcmx,4,20000),
     :              asuba(nspcmx,4,20000),ksub
      common/occ/   aocc(3,0:4,0:4,0:4,0:4),nfree
      common/radf/  ardf(3,nspcmx,nspcmx),
     :              rdf(3,nspcmx,nspcmx,nrgmx),
     :              drdf,nrdf,calrdf
      common/geo/   za0(8),ra0(8),ra(8),ta1(8),ta2(8),zl1(6),rl1(6),
     :              zl2(6),rl2(6),qpr(12),al(6),bl(6),
     :              tgalfa(6),csalfa(6),alfa(6),ric
      character*11  fgz,fgin,fc,fout,fnaca,fh,fdata,focc
      character*15  frdf
      character*2   fion
      character*4   fsalt
      logical       chonly
      logical       calrdf,calgin
      dimension     uasign(8),ulsign(6),deltah(npchmx)
      
      open(2,file="geometry.dat")
      read(2,*)         
      read(2,*)narch            
      read(2,*)        

      do i=1,narch
       read(2,*)za0(i),ra0(i),ra(i)
       read(2,*)ta1(i),ta2(i)      
      read(2,*)        
      enddo

      read(2,*)        
      read(2,*)nline      
      read(2,*)        
  
      do i=1,nline
       read(2,*)zl1(i),rl1(i)
       read(2,*)zl2(i),rl2(i)
       read(2,*)alfa(i),tgalfa(i)
       read(2,*)
       csalfa(i)=dcos(alfa(i))
      enddo

      read(2,*)        
      read(2,*)nwall
      read(2,*)        

      do i=nline+1,nline+nwall
       read(2,*)zl1(i),rl1(i)
       read(2,*)zl2(i),rl2(i)
       read(2,*)alfa(i)     
       read(2,*)        
      enddo
     
      read(2,*)        
      read(2,*)                            
      read(2,*)        
      do i=1,narch
       read(2,*)uasign(i)
      enddo
      do i=1,nline
       read(2,*)ulsign(i)
      enddo
      do i=nline+1,nline+nwall
       read(2,*)ulsign(i)
      enddo
      
      read(2,*)           
      read(2,*)           
      read(2,*)nchg
      read(2,*)        
  
      do i=1,nchg
       read(2,*)rx(i),ry(i),rz(i)
       read(2,*)qpr(i)     
       read(2,*)        
      enddo
      n(1)=nchg
       
      close(2)

c#####################################################################
c#####################################################################
c#####  Overlap ######################################################
c#####################################################################
c#####################################################################
!arch1 and line 1
      call linpar(za0(1),ra0(1),zl1(1),rl1(1),a0,b0)
      al(1)=a0
      bl(1)=b0
!line2 and arch 2
      call linpar(zl2(2),rl2(2),za0(2),ra0(2),a0,b0)
      al(2)=a0
      bl(2)=b0
!arch 2 and arch 3
      call linpar(za0(2),ra0(2),za0(3),ra0(3),a0,b0)
      al(3)=a0
      bl(3)=b0
      
!what about arch3/line3 and line3/arch4?
!right angle so don't have to worry about it i guess
      
!arch 4 and arch 5
      call linpar(za0(4),ra0(4),za0(5),ra0(5),a0,b0)
      al(4)=a0
      bl(4)=b0

!arch 5 and arch 6
      call linpar(za0(5),ra0(5),za0(6),ra0(6),a0,b0)
      al(5)=a0
      bl(5)=b0

!line1 and line2
      call linpar(zl1(1),rl1(1),zl2(2),rl2(2),a0,b0)
      al(6)=a0
      bl(6)=b0


c      echg=1.6021917d-19
!loop through the fixed charges
!n(1) stores number of charges
      do i=1,n(1)
!r2 will be radius
       r2(i)=dsqrt(rx(i)**2+ry(i)**2)
c       qpr(i)=qpr(i)/echg
      enddo 
!qpr(1) is charge of oxygen, which is -0.811
!qfar = -3.622      
      qfar=2*(-1-qpr(1))
!
      write(*,*)" qfar = ",qfar
      
!for all of the fixed charges, multiply by qstar      
      do i=1,n(1)
       qpr(i)=qpr(i)*qstar
      enddo
      qfar=qfar*qstar
!	 tsi=300.0      
!      dsi=1.d-10
!      eps0=8.8542d-12
!      boltz=1.3806d-23
!      echg=1.6021917d-19
!      beta=1./(boltz*tsi)
!      qstar=echg*dsqrt(beta/(4*pi*eps0*dsi))
!here is where we get qstar from the main program
c_______________________________________________________________________

      itry(1)=0
      z(1)=0.0
      d(1)=0.1

      u0(1,1)=0.0
      u0(1,2)=0.0
      u0(2,1)=0.0
      u0(1,3)=0.0
      u0(3,1)=0.0
      u0(1,4)=0.0
      u0(4,1)=0.0

      u0(2,4)=16.8
      u0(4,2)=u0(2,4)
      u0(2,3)=8.5
      u0(3,2)=u0(2,3)
      u0(3,4)=1.7
      u0(4,3)=u0(3,4)
      u0(3,3)=2.5
      u0(4,4)=0.8
      u0(2,2)=1.4

      eb(3)=0.721
      eb(2)=0.517
      eb(4)=2.737

      return
      end

c_______________________________________________________________________
c_______________________________________________________________________

      subroutine linpar(x1,y1,x2,y2,a,b)
      implicit doubleprecision (a-h,o-z)
      a=(y2-y1)/(x2-x1)
!a=rise/run      
      b=(x1*y2-x2*y1)/(x1-x2)
!b=is y intercept
      return
      end

c_______________________________________________________________________
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      subroutine wall(x,y,dist,ovrlap)
      implicit doubleprecision (a-h,o-z)
      parameter(nionmx=2000,ntotmx=12000,ntrymx=12000,npchmx=2000, 
     :          nspcmx=6,nzgmx=4000,nrgmx=500)
      common/const/ pi,twopi,tosi,u0(4,4),eb(4),beta,dsi,mag
      common/conf/  rx(ntotmx),ry(ntotmx),rz(ntotmx),r2(ntotmx),
     :              indspc(nspcmx,nionmx),rii(ntotmx,ntotmx), 
     :              n(nspcmx),ispcbk(ntotmx)
      common/spec/  d(nspcmx),dd(nspcmx,nspcmx),d2(nspcmx,nspcmx),
     :              z(nspcmx),q(nspcmx),
     :              ratmov(nspcmx),ratexc(nspcmx), 
     :              eps(nspcmx),qstar,itry(nspcmx),
     :              chonly(nspcmx),
     :              nspec,nwh(ntrymx),ntry,istr
      common/geom/  zl(6),rl(6),rlvest,rlcurv,epsw,epspr
      common/patch/ px(npchmx),py(npchmx),pz(npchmx),h(npchmx),
     :              ux(npchmx),uy(npchmx),uz(npchmx),a(npchmx),
     :              amx(npchmx,npchmx),c(npchmx),deps,
     :              rip(ntotmx,npchmx),
     :              npatch,indx(npchmx),npch(10)
      common/moove/ drmax(2),vin(nspcmx),vout(nspcmx),rljpin(nspcmx),
     :              zljpin(nspcmx) 
      common/gc/    chemp(3),ctarg(3),vgc(4,3),riicrn(4,4),
     :              rxnew(4),rynew(4),rznew(4),r2new(4),
     :              chex(3),ctrgcl,ratgr(3),ratgrt,ratreg(4),
     :              zcr1(4,nspcmx),zcr2(4,nspcmx),rcr(4,nspcmx),
     :              iout(4),ispcin(3,4),igcval(3),
     :              isalt(3),ication(3),nsalt,ntot,niter,iter
      common/names/ fion(10),fsalt(10),fgz(10),fgin(10),fc,fout,fh,
     :              fnaca(10,4),fdata,focc,frdf(10,10)
      common/profl/ athist,ataccu,dzg(10,nspcmx),drg, 
     :              vjz(nspcmx,nzgmx),vjin(nspcmx,nrgmx,nrgmx),
     :              rgz(nspcmx,nzgmx),rgin(nspcmx,nrgmx),
     :              gz(nspcmx,nzgmx),gin(nspcmx,nrgmx,nrgmx),
     :              zinlft,rinup,zzreg(0:10,nspcmx),dzgi(nspcmx,nzgmx),
     :              nzg(10,nspcmx),nrg,nrgr,nrgz,nzgtot(nspcmx),
     :              nzreg(nspcmx),calgin
      common/accu/  an(nspcmx),ah(npchmx),anin(4,nspcmx),
     :              zreg1(4,nspcmx),zreg2(4,nspcmx),rreg(4,nspcmx), 
     :              cbulk(nspcmx),zocc,indreg(3,nspcmx,nionmx),
     :              nin(4,nspcmx) 
      common/adj/   amove(2,nspcmx),ajump(2,nspcmx),ajin(2,nspcmx), 
     :              ajout(2,nspcmx),acreat(4,3,2),adest(4,3,2)
      common/bufer/ hold(npchmx), cold(npchmx),ripnew(nspcmx,npchmx),
     :              riinew(nspcmx,ntotmx),dc(npchmx),dh(npchmx),
     :              distin(4) 
      common/simp/  nstep,naver,isave
      common/bulk/  zbulk1,zbulk2,rbulk,vbulk,anaca(nspcmx,4,20000),
     :              asuba(nspcmx,4,20000),ksub
      common/occ/   aocc(3,0:4,0:4,0:4,0:4),nfree
      common/radf/  ardf(3,nspcmx,nspcmx),
     :              rdf(3,nspcmx,nspcmx,nrgmx),
     :              drdf,nrdf,calrdf
      common/geo/   za0(8),ra0(8),ra(8),ta1(8),ta2(8),zl1(6),rl1(6),
     :              zl2(6),rl2(6),qpr(12),al(6),bl(6),
     :              tgalfa(6),csalfa(6),alfa(6),ric
      character*11  fgz,fgin,fc,fout,fnaca,fh,fdata,focc
      character*15  frdf
      character*2   fion
      character*4   fsalt
      logical       chonly
      logical       calrdf,calgin
      logical ovrlap
      ovrlap=.false.

      ric=0.5
!left/right boundary
      if (dabs(x).gt.zl(4)) then
        ovrlap=.true.
        return
      endif
!outer boundary        
      if (y.gt.rl(5)) then
        ovrlap=.true.
        return
      endif


c -- 1 ---------------------------------------------
      if (x.le.zl1(6)-ric.and.y.ge.rl1(6)) then
        dist=zl1(6)-x
        return
      endif  
        
c -- 2 ---------------------------------------------
      if (x.ge.zl1(5)+ric.and.y.ge.rl1(5)) then
        dist=x-zl1(5)
        return
      endif
      
c -- 1 ____-----------------------------------------
      if (x.lt.0.and.y.ge.rl1(6)) then
        ovrlap=.true.
        return
      endif

c -- 2 ____-----------------------------------------
      if (x.gt.0.and.y.ge.rl1(5)) then
        ovrlap=.true.
        return
      endif

c -- 6 ---------------------------------------------
      y01=al(1)*x+bl(1)
      if (y.le.rl1(6).and.y.le.y01) then
        distsq=(x-za0(1))**2+(y-ra0(1))**2
        rrsq=(ric+ra(1))**2
        if (distsq.ge.rrsq) then
          dist=dsqrt(distsq)-ra(1)
          return
        else
          ovrlap=.true.
          return
        endif  
      endif

c -- 7 ---------------------------------------------
      y02=al(2)*x+bl(2)
      y06=al(6)*x+bl(6)
      if (y.gt.y01.and.y.le.y02) then
        if (y.gt.y06) then
          ovrlap=.true.
          return
        else  
          dist=(al(6)*x+bl(6)-y)*csalfa(1)
          if (dist.le.ric) then
            ovrlap=.true.
            return
          endif  
        endif
      endif  

c -- 8 ---------------------------------------------
      y03=al(3)*x+bl(3)
      if (y.ge.y02.and.y.ge.y03) then
        distsq=(x-za0(2))**2+(y-ra0(2))**2
        rrsq=(ra(2)-ric)**2
        if (distsq.le.rrsq) then
          dist=ra(2)-dsqrt(distsq)
          return
        else
          ovrlap=.true.
          return
        endif  
      endif

c -- 9 ---------------------------------------------
      if (x.le.zl1(3).and.y.le.y03.and.y.gt.y02) then
        distsq=(x-za0(3))**2+(y-ra0(3))**2
        rrsq=(ric+ra(3))**2
        if (distsq.ge.rrsq) then
          dist=dsqrt(distsq)-ra(3)
          return
        else
          ovrlap=.true.
          return
        endif  
      endif

c -- 10---------------------------------------------
      if (x.ge.zl1(3).and.x.le.zl2(3)) then
        if (y.gt.rl1(3)-ric) then
          ovrlap=.true.
          return
        else  
          dist=rl1(3)-y
          return
c          if (dist.le.ri) then
c            ovrlap=.true.
c            return
c          endif  
        endif
      endif  

c -- 11 --------------------------------------------
      y04=al(4)*x+bl(4)
      if (x.ge.zl2(3).and.y.le.y04) then
        distsq=(x-za0(4))**2+(y-ra0(4))**2
        rrsq=(ric+ra(4))**2
        if (distsq.ge.rrsq) then
          dist=dsqrt(distsq)-ra(4)
          return
        else
          ovrlap=.true.
          return
        endif  
      endif

c -- 12 --------------------------------------------
      y05=al(5)*x+bl(5)
      if (y.ge.y04.and.y.le.y05) then
        distsq=(x-za0(5))**2+(y-ra0(5))**2
        rrsq=(ra(5)-ric)**2
        if (distsq.le.rrsq) then
          dist=ra(5)-dsqrt(distsq)
          return
        else
          ovrlap=.true.
          return
        endif  
      endif

c -- 13 --------------------------------------------
      if (y.ge.y05.and.y.le.rl1(5)) then
        distsq=(x-za0(6))**2+(y-ra0(6))**2
        rrsq=(ric+ra(6))**2
        if (distsq.ge.rrsq) then
          dist=dsqrt(distsq)-ra(6)
          return
        else
          ovrlap=.true.
          return
        endif  
      endif

      return
      end

