      program makesh
      common names(400)
      character*13 names
      character*12 jname
      character*40 pathml
      integer wtime

      call gnames
     
      open(2,file="in.dat")
       read(2,*)
       read(2,*)
       read(2,*)
       read(2,*)nrun
       read(2,*)pathml
       read(2,*)jname 
       read(2,*)wtime
      close(2)

      do i=1,nrun
       open(2,file=names(i))
       write(2,'("#!/bin/bash")')
       write(2,'("#PBS -l nodes=1:ppn=1,walltime=",i2,":00:00 ")')wtime
       
       if (i.le.9) then
        write(2,'("#PBS -N ",a6,".00",i1)')jname,i
       elseif (i.le.99) then
        write(2,'("#PBS -N ",a6,".0",i2)')jname,i
       else
        write(2,'("#PBS -N ",a6,".",i3)')jname,i
       endif
       
       write(2,'("#PBS -m abe")')
       write(2,'("#PBS -M boda@chem.byu.edu")')
       
       if (i.le.9) then
        write(2,'("PROG=",a33,"channel00",i1)')pathml,i
       elseif (i.le.99) then
        write(2,'("PROG=",a33,"channel0",i2)')pathml,i
       else
        write(2,'("PROG=",a33,"channel",i3)')pathml,i
       endif
       
       write(2,*) 
       write(2,'("PROGARGS="""" ")')
       write(2,'("cd $PBS_O_WORKDIR")')
       write(2,'("$PROG $PROGARGS")')
       write(2,'("exit 0")')
       close(2)
      enddo
     
      open(2,file="start.exe")
      do i=1,nrun
       write(2,'("qsub ",a13)')names(i) 
      enddo
      close(2)

      stop
      end
      

      subroutine gnames
      common names(400)
      character*13 names
      names(1) ="j001.sh"
      names(2) ="j002.sh"
      names(3) ="j003.sh"
      names(4) ="j004.sh"
      names(5) ="j005.sh"
      names(6) ="j006.sh"
      names(7) ="j007.sh"
      names(8) ="j008.sh"
      names(9) ="j009.sh"
      names(10)="j010.sh"
      names(11)="j011.sh"
      names(12)="j012.sh"
      names(13)="j013.sh"
      names(14)="j014.sh"
      names(15)="j015.sh"
      names(16)="j016.sh"
      names(17)="j017.sh"
      names(18)="j018.sh"
      names(19)="j019.sh"
      names(20)="j020.sh"
      names(21)="j021.sh"
      names(22)="j022.sh"
      names(23)="j023.sh"
      names(24)="j024.sh"
      names(25)="j025.sh"
      names(26)="j026.sh"
      names(27)="j027.sh"
      names(28)="j028.sh"
      names(29)="j029.sh"
      names(30)="j030.sh"
      names(31)="j031.sh"
      names(32)="j032.sh"
      names(33)="j033.sh"
      names(34)="j034.sh"
      names(35)="j035.sh"
      names(36)="j036.sh"
      names(37)="j037.sh"
      names(38)="j038.sh"
      names(39)="j039.sh"
      names(40)="j040.sh"
      names(41)="j041.sh"
      names(42)="j042.sh"
      names(43)="j043.sh"
      names(44)="j044.sh"
      names(45)="j045.sh"
      names(46)="j046.sh"
      names(47)="j047.sh"
      names(48)="j048.sh"
      names(49)="j049.sh"
      names(50)="j050.sh"
      names(51)="j051.sh"
      names(52)="j052.sh"
      names(53)="j053.sh"
      names(54)="j054.sh"
      names(55)="j055.sh"
      names(56)="j056.sh"
      names(57)="j057.sh"
      names(58)="j058.sh"
      names(59)="j059.sh"
      names(60)="j060.sh"
      names(61)="j061.sh"
      names(62)="j062.sh"
      names(63)="j063.sh"
      names(64)="j064.sh"
      names(65)="j065.sh"
      names(66)="j066.sh"
      names(67)="j067.sh"
      names(68)="j068.sh"
      names(69)="j069.sh"
      names(70)="j070.sh"
      names(71)="j071.sh"
      names(72)="j072.sh"
      names(73)="j073.sh"
      names(74)="j074.sh"
      names(75)="j075.sh"
      names(76)="j076.sh"
      names(77)="j077.sh"
      names(78)="j078.sh"
      names(79)="j079.sh"
      names(80)="j080.sh"
      names(81)="j081.sh"
      names(82)="j082.sh"
      names(83)="j083.sh"
      names(84)="j084.sh"
      names(85)="j085.sh"
      names(86)="j086.sh"
      names(87)="j087.sh"
      names(88)="j088.sh"
      names(89)="j089.sh"
      names(90)="j090.sh"
      names(91)="j091.sh"
      names(92)="j092.sh"
      names(93)="j093.sh"
      names(94)="j094.sh"
      names(95)="j095.sh"
      names(96)="j096.sh"
      names(97)="j097.sh"
      names(98)="j098.sh"
      names(99)="j099.sh"
      names(100)="j100.sh"
      names(101)="j101.sh"
      names(102)="j102.sh"
      names(103)="j103.sh"
      names(104)="j104.sh"
      names(105)="j105.sh"
      names(106)="j106.sh"
      names(107)="j107.sh"
      names(108)="j108.sh"
      names(109)="j109.sh"
      names(110)="j110.sh"
      names(111)="j111.sh"
      names(112)="j112.sh"
      names(113)="j113.sh"
      names(114)="j114.sh"
      names(115)="j115.sh"
      names(116)="j116.sh"
      names(117)="j117.sh"
      names(118)="j118.sh"
      names(119)="j119.sh"
      names(120)="j120.sh"
      names(121)="j121.sh"
      names(122)="j122.sh"
      names(123)="j123.sh"
      names(124)="j124.sh"
      names(125)="j125.sh"
      names(126)="j126.sh"
      names(127)="j127.sh"
      names(128)="j128.sh"
      names(129)="j129.sh"
      names(130)="j130.sh"
      names(131)="j131.sh"
      names(132)="j132.sh"
      names(133)="j133.sh"
      names(134)="j134.sh"
      names(135)="j135.sh"
      names(136)="j136.sh"
      names(137)="j137.sh"
      names(138)="j138.sh"
      names(139)="j139.sh"
      names(140)="j140.sh"
      names(141)="j141.sh"
      names(142)="j142.sh"
      names(143)="j143.sh"
      names(144)="j144.sh"
      names(145)="j145.sh"
      names(146)="j146.sh"
      names(147)="j147.sh"
      names(148)="j148.sh"
      names(149)="j149.sh"
      names(150)="j150.sh"
      names(151)="j151.sh"
      names(152)="j152.sh"
      names(153)="j153.sh"
      names(154)="j154.sh"
      names(155)="j155.sh"
      names(156)="j156.sh"
      names(157)="j157.sh"
      names(158)="j158.sh"
      names(159)="j159.sh"
      names(160)="j160.sh"
      names(161)="j161.sh"
      names(162)="j162.sh"
      names(163)="j163.sh"
      names(164)="j164.sh"
      names(165)="j165.sh"
      names(166)="j166.sh"
      names(167)="j167.sh"
      names(168)="j168.sh"
      names(169)="j169.sh"
      names(170)="j170.sh"
      names(171)="j171.sh"
      names(172)="j172.sh"
      names(173)="j173.sh"
      names(174)="j174.sh"
      names(175)="j175.sh"
      names(176)="j176.sh"
      names(177)="j177.sh"
      names(178)="j178.sh"
      names(179)="j179.sh"
      names(180)="j180.sh"
      names(181)="j181.sh"
      names(182)="j182.sh"
      names(183)="j183.sh"
      names(184)="j184.sh"
      names(185)="j185.sh"
      names(186)="j186.sh"
      names(187)="j187.sh"
      names(188)="j188.sh"
      names(189)="j189.sh"
      names(190)="j190.sh"
      names(191)="j191.sh"
      names(192)="j192.sh"
      names(193)="j193.sh"
      names(194)="j194.sh"
      names(195)="j195.sh"
      names(196)="j196.sh"
      names(197)="j197.sh"
      names(198)="j198.sh"
      names(199)="j199.sh"
      names(200)="j200.sh"
      names(201)="j201.sh"
      names(202)="j202.sh"
      names(203)="j203.sh"
      names(204)="j204.sh"
      names(205)="j205.sh"
      names(206)="j206.sh"
      names(207)="j207.sh"
      names(208)="j208.sh"
      names(209)="j209.sh"
      names(210)="j210.sh"
      names(211)="j211.sh"
      names(212)="j212.sh"
      names(213)="j213.sh"
      names(214)="j214.sh"
      names(215)="j215.sh"
      names(216)="j216.sh"
      names(217)="j217.sh"
      names(218)="j218.sh"
      names(219)="j219.sh"
      names(220)="j220.sh"
      names(221)="j221.sh"
      names(222)="j222.sh"
      names(223)="j223.sh"
      names(224)="j224.sh"
      names(225)="j225.sh"
      names(226)="j226.sh"
      names(227)="j227.sh"
      names(228)="j228.sh"
      names(229)="j229.sh"
      names(230)="j230.sh"
      names(231)="j231.sh"
      names(232)="j232.sh"
      names(233)="j233.sh"
      names(234)="j234.sh"
      names(235)="j235.sh"
      names(236)="j236.sh"
      names(237)="j237.sh"
      names(238)="j238.sh"
      names(239)="j239.sh"
      names(240)="j240.sh"
      names(241)="j241.sh"
      names(242)="j242.sh"
      names(243)="j243.sh"
      names(244)="j244.sh"
      names(245)="j245.sh"
      names(246)="j246.sh"
      names(247)="j247.sh"
      names(248)="j248.sh"
      names(249)="j249.sh"
      names(250)="j250.sh"
      names(251)="j251.sh"
      names(252)="j252.sh"
      names(253)="j253.sh"
      names(254)="j254.sh"
      names(255)="j255.sh"
      names(256)="j256.sh"
      names(257)="j257.sh"
      names(258)="j258.sh"
      names(259)="j259.sh"
      names(260)="j260.sh"
      names(261)="j261.sh"
      names(262)="j262.sh"
      names(263)="j263.sh"
      names(264)="j264.sh"
      names(265)="j265.sh"
      names(266)="j266.sh"
      names(267)="j267.sh"
      names(268)="j268.sh"
      names(269)="j269.sh"
      names(270)="j270.sh"
      names(271)="j271.sh"
      names(272)="j272.sh"
      names(273)="j273.sh"
      names(274)="j274.sh"
      names(275)="j275.sh"
      names(276)="j276.sh"
      names(277)="j277.sh"
      names(278)="j278.sh"
      names(279)="j279.sh"
      names(280)="j280.sh"
      names(281)="j281.sh"
      names(282)="j282.sh"
      names(283)="j283.sh"
      names(284)="j284.sh"
      names(285)="j285.sh"
      names(286)="j286.sh"
      names(287)="j287.sh"
      names(288)="j288.sh"
      names(289)="j289.sh"
      names(290)="j290.sh"
      names(291)="j291.sh"
      names(292)="j292.sh"
      names(293)="j293.sh"
      names(294)="j294.sh"
      names(295)="j295.sh"
      names(296)="j296.sh"
      names(297)="j297.sh"
      names(298)="j298.sh"
      names(299)="j299.sh"
      names(300)="j300.sh"
      names(301)="j301.sh"
      names(302)="j302.sh"
      names(303)="j303.sh"
      names(304)="j304.sh"
      names(305)="j305.sh"
      names(306)="j306.sh"
      names(307)="j307.sh"
      names(308)="j308.sh"
      names(309)="j309.sh"
      names(310)="j310.sh"
      names(311)="j311.sh"
      names(312)="j312.sh"
      names(313)="j313.sh"
      names(314)="j314.sh"
      names(315)="j315.sh"
      names(316)="j316.sh"
      names(317)="j317.sh"
      names(318)="j318.sh"
      names(319)="j319.sh"
      names(320)="j320.sh"
      names(321)="j321.sh"
      names(322)="j322.sh"
      names(323)="j323.sh"
      names(324)="j324.sh"
      names(325)="j325.sh"
      names(326)="j326.sh"
      names(327)="j327.sh"
      names(328)="j328.sh"
      names(329)="j329.sh"
      names(330)="j330.sh"
      names(331)="j331.sh"
      names(332)="j332.sh"
      names(333)="j333.sh"
      names(334)="j334.sh"
      names(335)="j335.sh"
      names(336)="j336.sh"
      names(337)="j337.sh"
      names(338)="j338.sh"
      names(339)="j339.sh"
      names(340)="j340.sh"
      names(341)="j341.sh"
      names(342)="j342.sh"
      names(343)="j343.sh"
      names(344)="j344.sh"
      names(345)="j345.sh"
      names(346)="j346.sh"
      names(347)="j347.sh"
      names(348)="j348.sh"
      names(349)="j349.sh"
      names(350)="j350.sh"
      names(351)="j351.sh"
      names(352)="j352.sh"
      names(353)="j353.sh"
      names(354)="j354.sh"
      names(355)="j355.sh"
      names(356)="j356.sh"
      names(357)="j357.sh"
      names(358)="j358.sh"
      names(359)="j359.sh"
      names(360)="j360.sh"
      names(361)="j361.sh"
      names(362)="j362.sh"
      names(363)="j363.sh"
      names(364)="j364.sh"
      names(365)="j365.sh"
      names(366)="j366.sh"
      names(367)="j367.sh"
      names(368)="j368.sh"
      names(369)="j369.sh"
      names(370)="j370.sh"
      names(371)="j371.sh"
      names(372)="j372.sh"
      names(373)="j373.sh"
      names(374)="j374.sh"
      names(375)="j375.sh"
      names(376)="j376.sh"
      names(377)="j377.sh"
      names(378)="j378.sh"
      names(379)="j379.sh"
      names(380)="j380.sh"
      names(381)="j381.sh"
      names(382)="j382.sh"
      names(383)="j383.sh"
      names(384)="j384.sh"
      names(385)="j385.sh"
      names(386)="j386.sh"
      names(387)="j387.sh"
      names(388)="j388.sh"
      names(389)="j389.sh"
      names(390)="j390.sh"
      names(391)="j391.sh"
      names(392)="j392.sh"
      names(393)="j393.sh"
      names(394)="j394.sh"
      names(395)="j395.sh"
      names(396)="j396.sh"
      names(397)="j397.sh"
      names(398)="j398.sh"
      names(399)="j399.sh"
      names(400)="j400.sh"
      return
      end   
